////////////////////////////////////////////////////////////////////////
// Class:       HorizontalMuonTrigger
// Module Type: filter
// File:        HorizontalMuonTrigger_module.cc
//
// Generated at Wed Jun 29 11:15:18 2016 by Norman Buchanan using artmod
// from cetpkgsupport v1_10_02.
////////////////////////////////////////////////////////////////////////

#include "art/Framework/Core/EDFilter.h"
#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"
#include "art/Framework/Principal/Run.h"
#include "art/Framework/Principal/SubRun.h"
#include "art/Utilities/InputTag.h"
#include "fhiclcpp/ParameterSet.h"
#include "messagefacility/MessageLogger/MessageLogger.h"

#include <memory>

#include "DDTBaseDataProducts/HitList.h"
#include "DDTBaseDataProducts/TriggerDecision.h"
#include "DDTBaseDataProducts/Track3D.h"
#include "DDTBaseDataProducts/EventHeader.h"


namespace novaddt {
  class HorizontalMuonTrigger;
}

class novaddt::HorizontalMuonTrigger : public art::EDFilter {
public:
  explicit HorizontalMuonTrigger(fhicl::ParameterSet const & p);
  // The destructor generated by the compiler is fine for classes
  // without bare pointers or other resource use.

  // Plugins should not be copied or assigned.
  HorizontalMuonTrigger(HorizontalMuonTrigger const &) = delete;
  HorizontalMuonTrigger(HorizontalMuonTrigger &&) = delete;
  HorizontalMuonTrigger & operator = (HorizontalMuonTrigger const &) = delete;
  HorizontalMuonTrigger & operator = (HorizontalMuonTrigger &&) = delete;

  // Required functions.
  bool filter(art::Event & e) override;


private:

  // Declare member data here.

  std::string fTrack3DLabel;



};


novaddt::HorizontalMuonTrigger::HorizontalMuonTrigger(fhicl::ParameterSet const & pset)
 : fTrack3DLabel(pset.get<std::string>("Track3DLabel")) 
{
  // Call appropriate produces<>() functions here.

}

bool novaddt::HorizontalMuonTrigger::filter(art::Event & evt)
{
  // Implementation of required member function here.
  
    // Grab the tracks from the event
    art::Handle<std::vector<Track3D>> tracks;
    evt.getByLabel(fTrack3DLabel, tracks);

    for (auto const & track : *tracks)
      {
	std::cout << "Track: " << track.Is3D() << std::endl;
	if (track.Is3D())
	  {
	    std::cout << "Track Start: "<< std::endl;
	    track.Start().Print();
	    std::cout << "Track End: "<< std::endl;
	    track.End().Print();
	  }

	//std::cout << "Track Start: " << track.Start().Print( << std::endl;
	//	std::cout << "Track End: " << track.End() << std::endl;
	
      }


  return (true);

}

DEFINE_ART_MODULE(novaddt::HorizontalMuonTrigger)
