#ifndef DDT_TRIGGERDECISION_H
#define DDT_TRIGGERDECISION_H


#include "DDTBaseDataProducts/BaseProducts.h"

#include <string>


namespace novaddt
{
  class TriggerDecision 
  {
  public:

    TriggerDecision();

#ifndef __GCCXML__
    TriggerDecision(TDC start, TDC duration,
		    TriggerMask mask, unsigned prescale,
		    long extra_info = 0);

    TDC::value_type         start()      const;
    TDC::value_type         duration()   const;
    TriggerMask::value_type mask()       const;
    unsigned                prescale()   const;
    long                    extra_info() const;

    TDC                     setStart(TDC::value_type start)
    {return _start=start;};
    TDC                     setDuration(TDC::value_type duration)
    {return _duration=duration;};
    TriggerMask             setMask(TriggerMask::value_type mask)
    {return _mask=mask;};
    unsigned                setPrescale(unsigned prescale)
    {return _prescale=prescale;};
    long                    setExtraInfo(long extra_info)
    {return _extra_info=extra_info;};

#endif
    ~TriggerDecision();

  private:
    TDC _start, _duration;
    TriggerMask _mask;
    unsigned    _prescale;
    long        _extra_info;
  };
}


#endif

