#ifndef SHAREDDATA__H
#define SHAREDDATA__H
#include <boost/interprocess/shared_memory_object.hpp>
#include <boost/interprocess/managed_shared_memory.hpp>

template<class dataType>
class SharedData{
    public:
        SharedData(const char* shmem_name, const char* data_name):
            fShmemName(shmem_name),
            fSegment(boost::interprocess::open_or_create,shmem_name,sizeof(dataType)*2)
            {
              std::cout<<"sizeof(dataType)="<<sizeof(dataType)<<std::endl;
              fData = fSegment.find_or_construct<dataType>(data_name)();
            }
        ~SharedData(){
            clearMem();
        }
        void clearMem(){
            boost::interprocess::shared_memory_object::remove(fShmemName);
        }
        dataType& getData(){return *fData;}
        const dataType& getData() const{return *fData;}
    protected:
        const char* fShmemName;
        boost::interprocess::managed_shared_memory fSegment;
        dataType* fData;
};
#endif
